Index: java/main/src/main/java/com/framsticks/model/Model.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Model.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/model/Model.java	(revision 84)
@@ -1,7 +1,8 @@
 package com.framsticks.model;
 
-import com.framsticks.util.Casting;
-import com.framsticks.util.Containers;
-import com.framsticks.util.Orientation;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Containers;
+import com.framsticks.util.lang.IterableIterator;
+import com.framsticks.util.math.Orientation;
 import org.apache.log4j.Logger;
 
@@ -15,5 +16,5 @@
 public class Model {
 
-	private final static Logger LOGGER = Logger.getLogger(Model.class);
+	private final static Logger log = Logger.getLogger(Model.class);
 
 	public Double startingEnergy;
@@ -53,9 +54,8 @@
 		Model f0Genotype = Casting.tryCast(Model.class, i.next());
 		if (f0Genotype == null) {
-			LOGGER.fatal("first object is not a Model");
+			log.fatal("first object is not a Model");
 			return null;
 		}
-		while (i.hasNext()) {
-			Object object = i.next();
+		for (Object object : new IterableIterator<Object>(i)) {
 			if (object instanceof Joint) {
 				f0Genotype.joints.add((Joint)object);
@@ -70,5 +70,5 @@
 				continue;
 			}
-			LOGGER.error("invalid class: " + object.getClass().getCanonicalName());
+			log.error("invalid class: " + object.getClass().getCanonicalName());
 		}
 
Index: java/main/src/main/java/com/framsticks/model/Neuro.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Neuro.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/model/Neuro.java	(revision 84)
@@ -1,5 +1,5 @@
 package com.framsticks.model;
 
-import com.framsticks.util.Point3d;
+import com.framsticks.util.math.Point3d;
 
 /**
Index: java/main/src/main/java/com/framsticks/model/Package.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Package.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/model/Package.java	(revision 84)
@@ -1,8 +1,5 @@
 package com.framsticks.model;
 
-import com.framsticks.params.FramsClass;
 import com.framsticks.params.Registry;
-import com.framsticks.util.Orientation;
-import com.framsticks.util.Point3d;
 
 /**
Index: java/main/src/main/java/com/framsticks/model/Part.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Part.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/model/Part.java	(revision 84)
@@ -2,5 +2,5 @@
 
 
-import com.framsticks.util.Point3d;
+import com.framsticks.util.math.Point3d;
 
 /**
Index: java/main/src/main/java/com/framsticks/observers/Endpoint.java
===================================================================
--- java/main/src/main/java/com/framsticks/observers/Endpoint.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/observers/Endpoint.java	(revision 84)
@@ -5,7 +5,6 @@
 import com.framsticks.core.Path;
 import com.framsticks.params.FramsClass;
-import com.framsticks.portals.PortalEndpoint;
 import com.framsticks.core.ListChange;
-import com.framsticks.util.Dispatcher;
+import com.framsticks.util.dispatching.Dispatcher;
 import org.apache.log4j.Logger;
 
@@ -14,68 +13,73 @@
  */
 public class Endpoint implements Dispatcher, InstanceListener {
-    private final static Logger LOGGER = Logger.getLogger(PortalEndpoint.class.getName());
+	private final static Logger log = Logger.getLogger(Endpoint.class.getName());
 
-    protected Instance instance;
-    protected Observer observer;
-    protected String name;
+	protected Instance instance;
+	protected Observer observer;
+	protected String name;
 
-    public Endpoint() {
-    }
+	public Endpoint() {
+	}
 
-    public final void configurePublic(Observer observer, Instance instance, String name) {
-        assert instance != null;
-        this.name = name;
-        this.observer = observer;
-        this.instance = instance;
-        instance.addListener(this);
-        configure();
-    }
+	public final void configurePublic(Observer observer, Instance instance, String name) {
+		assert instance != null;
+		this.name = name;
+		this.observer = observer;
+		this.instance = instance;
+		instance.addListener(this);
+	}
 
-    protected void configure() {
+	public void start() {
+		instance.start();
+	}
 
-    }
+	@Override
+	public void onListChange(Path path, ListChange change) {
+		log.info("change " + change + " in " + path);
+	}
 
-    @Override
-    public void onListChange(Path path, ListChange change) {
-        LOGGER.info("change " + change + " in " + path);
-    }
+	@Override
+	public void onRun(Exception e) {
+	}
 
-    @Override
-    public void onRun(Exception e) {
-    }
+	@Override
+	public void onStop(Exception e) {
+	}
 
-    @Override
-    public void onStop(Exception e) {
-    }
+	@Override
+	public void onFetch(Path path) {
+		log.trace("fetched " + path);
+	}
 
-    @Override
-    public String toString() {
-        return instance.toString();
-    }
+	@Override
+	public String toString() {
+		return instance.toString();
+	}
 
-    public final Instance getInstance() {
-        return instance;
-    }
+	public final Instance getInstance() {
+		return instance;
+	}
 
-    @Override
-    public final boolean isActive() {
-        return instance.isActive();
-    }
+	@Override
+	public final boolean isActive() {
+		return instance.isActive();
+	}
 
-    @Override
-    public final void invokeLater(Runnable runnable) {
-        instance.invokeLater(runnable);
-    }
+	@Override
+	public final void invokeLater(Runnable runnable) {
+		instance.invokeLater(runnable);
+	}
 
-    public Observer getObserver() {
-        return observer;
-    }
+	public Observer getObserver() {
+		return observer;
+	}
 
-    public final String getName() {
-        return name;
-    }
+	public final String getName() {
+		return name;
+	}
 
-    public static void constructFramsClass(FramsClass.Constructor constructor) {
-        constructor.method("getName").method("getInstance");
-    }
+	public static void constructFramsClass(FramsClass.Constructor constructor) {
+		constructor.method("getName").method("getInstance");
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/observers/Observer.java
===================================================================
--- java/main/src/main/java/com/framsticks/observers/Observer.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/observers/Observer.java	(revision 84)
@@ -3,8 +3,7 @@
 import com.framsticks.core.Entity;
 import com.framsticks.core.Instance;
-import com.framsticks.core.Parameters;
 import com.framsticks.core.Program;
 import com.framsticks.params.FramsClass;
-import com.framsticks.util.Casting;
+import com.framsticks.util.lang.Casting;
 import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
@@ -17,56 +16,59 @@
 public abstract class Observer extends Entity {
 
-    private final static Logger LOGGER = Logger.getLogger(Observer.class.getName());
+	private final static Logger log = Logger.getLogger(Observer.class.getName());
 
-    public Observer(Parameters parameters) {
-        super(parameters);
-    }
+	public Observer() {
+	}
 
-    protected final Map<String, Endpoint> endpoints = new HashMap<String, Endpoint>();
+	protected final Map<String, Endpoint> endpoints = new HashMap<String, Endpoint>();
 
-    protected Endpoint createEndpoint() {
-        return new Endpoint();
-    }
+	protected Endpoint createEndpoint() {
+		return new Endpoint();
+	}
 
-    @Override
-    protected void configure() throws Exception {
-        super.configure();
-        for (String name : config.getStringArray("endpoints")) {
-            if (getEndpoints().containsKey(name)) {
-                LOGGER.fatal("observer already contains endpoint named: " + name);
-                continue;
-            }
-            Configuration c = config.subset("endpoints." + name);
-            Parameters p = new Parameters(c.subset("entity"), name, null, null);
-            Entity e = Program.configureEntity(p);
-            Instance i = Casting.tryCast(Instance.class, e);
-            if (i == null) {
-                LOGGER.error("failed to create instance: " + p);
-                continue;
-            }
-            i.configurePublic();
-            Endpoint endpoint = createEndpoint();
-            endpoint.configurePublic(this, i, name);
-            getEndpoints().put(name, endpoint);
-            LOGGER.info("instance " + i + " was added to " + Observer.this);
-        }
-    }
+	@Override
+	public void configure(Configuration config) {
+		super.configure(config);
+		for (String n : config.getStringArray("endpoints")) {
+			if (getEndpoints().containsKey(n)) {
+				log.fatal("observer already contains endpoint named: " + n);
+				continue;
+			}
+			Configuration instanceConfig = config.subset("endpoints." + n).subset("entity");
+			Instance i = Casting.tryCast(Instance.class, Program.configureEntity(instanceConfig));
+			if (i == null) {
+				log.error("failed to create instance: ");
+				continue;
+			}
+			i.setName(n);
+			i.configure(instanceConfig);
+			addEndpointForInstance(i);
+		}
+	}
 
-    @Override
-    protected void run() {
-        super.run();
-        for (Endpoint e : getEndpoints().values()) {
-            e.getInstance().start();
-        }
-    }
+	public Endpoint addEndpointForInstance(Instance instance) {
+		Endpoint endpoint = createEndpoint();
+		endpoint.configurePublic(this, instance, instance.getName());
+		getEndpoints().put(instance.getName(), endpoint);
+		log.info("instance " + instance + " was added to " + this + " as " + instance.getName());
+		return endpoint;
+	};
+
+	@Override
+	protected void run() {
+		super.run();
+		for (Endpoint e : getEndpoints().values()) {
+			e.start();
+		}
+	}
 
 
-    public Map<String, Endpoint> getEndpoints() {
-        return endpoints;
-    }
+	public Map<String, Endpoint> getEndpoints() {
+		return endpoints;
+	}
 
-    public static void constructFramsClass(FramsClass.Constructor constructor) {
-        constructor.method("getEndpoints");
-    }
+	public static void constructFramsClass(FramsClass.Constructor constructor) {
+		constructor.method("getEndpoints");
+	}
 
 
Index: java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 84)
@@ -2,5 +2,4 @@
 
 import java.util.Collection;
-import java.util.List;
 
 
@@ -9,5 +8,5 @@
  * framsticks. In descriptions of methods names "property" and "parameter" are
  * synonyms.
- * 
+ *
  * @author Jarek Szymczak <name.surname@gmail.com> (please replace name and
  *         surname with my personal data)
@@ -20,16 +19,4 @@
 
 	String getId();
-
-
-    /*
-    	String getName();
-
-    * This method provides more verbose (but not strict) names of classes.
-     *
-     * e.g. for a list it will return l Type, and if name of FramsClass missing,
-     * it's id will be used
-     *
-    String getNiceName();
-    */
 
 	Param getGroupMember(int gi, int n);
@@ -44,5 +31,5 @@
 	<T> T get(String id, Class<T> type);
 
-	<T> T get(Param param, Class<T> type);
+	<T> T get(ValueParam param, Class<T> type);
 
 	<T> int set(int i, T value);
@@ -50,5 +37,5 @@
 	<T> int set(String id, T value);
 
-	<T> int set(Param param, T value);
+	<T> int set(ValueParam param, T value);
 
 	void setDefault(boolean numericOnly);
@@ -71,18 +58,9 @@
 
 	/**
-	 * Return as a single line String.
-	 * 
-	 * @param omitDefaultValues
-	 *            the omit default values
-	 * @return the string
-	 */
-	String save2(boolean omitDefaultValues);
-
-	/**
 	 * Removes all the properties values.
 	 */
 	void clearValues();
 
-	void select(Object object);
+	AccessInterface select(Object object);
 
 	Object getSelected();
@@ -90,9 +68,9 @@
 	AccessInterface cloneAccess();
 
-    Object createAccessee();
+	Object createAccessee();
 
-    Collection<Param> getParams();
+	Collection<Param> getParams();
 
-    FramsClass getFramsClass();
+	FramsClass getFramsClass();
 
 
Index: java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 84)
@@ -1,5 +1,5 @@
 package com.framsticks.params;
 
-import com.framsticks.util.Numbers;
+import com.framsticks.util.lang.Numbers;
 
 import java.util.ArrayList;
@@ -13,111 +13,112 @@
 public class ArrayListAccess extends ListAccess {
 
-    List list;
+	List<Object> list;
 
+	public ArrayListAccess(AccessInterface elementAccess) {
+		super(elementAccess);
+	}
 
-    public ArrayListAccess(AccessInterface elementAccess) {
-        super(elementAccess);
-    }
+	@Override
+	public ArrayListAccess cloneAccess() {
+		return new ArrayListAccess(elementAccess.cloneAccess());
+	}
 
-    @Override
-    public ArrayListAccess cloneAccess() {
-        return new ArrayListAccess(elementAccess.cloneAccess());
-    }
+	@Override
+	public List<?> createAccessee() {
+		return new ArrayList<Object>();
+	}
 
-    @Override
-    public List createAccessee() {
-        return new ArrayList();
-    }
+	@Override
+	public Param getParam(int i) {
+		return new ParamBuilder().setId(Integer.toString(i)).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
+	}
 
-    @Override
-    public Param getParam(int i) {
-        return new ParamBuilder().setId(Integer.toString(i)).setName(elementAccess.getId()).setType("o " + elementAccess.getId()).build();
-    }
+	@Override
+	public Param getParam(String id) {
+		Integer i = Numbers.parse(id, Integer.class);
+		return (i == null ? null : getParam(i));
+	}
 
-    @Override
-    public Param getParam(String id) {
-        Integer i = Numbers.parse(id, Integer.class);
-        return (i == null ? null : getParam(i));
-    }
+	@Override
+	public String getId() {
+		return "l " + elementAccess.getId();
+	}
 
-    @Override
-    public String getId() {
-        return "l " + elementAccess.getId();
-    }
+	@Override
+	public int getParamCount() {
+		return list.size();
+	}
 
-    @Override
-    public int getParamCount() {
-        return list.size();
-    }
+	@Override
+	public <T> T get(int i, Class<T> type) {
+		if (i < list.size()) {
+			return type.cast(list.get(i));
+		}
+		return null;
+	}
 
-    @Override
-    public <T> T get(int i, Class<T> type) {
-        if (i < list.size()) {
-            return type.cast(list.get(i));
-        }
-        return null;
-    }
+	@Override
+	public <T> T get(String id, Class<T> type) {
+		return get(Integer.parseInt(id), type);
+	}
 
-    @Override
-    public <T> T get(String id, Class<T> type) {
-        return get(Integer.parseInt(id), type);
-    }
+	@Override
+	public <T> T get(ValueParam param, Class<T> type) {
+		return get(param.getId(), type);
+	}
 
-    @Override
-    public <T> T get(Param param, Class<T> type) {
-        return get(param.getId(), type);
-    }
+	@Override
+	public <T> int set(int i, T value) {
+		while (i >= list.size()) {
+			list.add(null);
+		}
+		list.set(i, value);
+		return 0;
+	}
 
-    @Override
-    public <T> int set(int i, T value) {
-        while (i >= list.size()) {
-            list.add(null);
-        }
-        list.set(i, value);
-        return 0;
-    }
+	@Override
+	public <T> int set(String id, T value) {
+		return set(Integer.parseInt(id), value);
+	}
 
-    @Override
-    public <T> int set(String id, T value) {
-        return set(Integer.parseInt(id), value);
-    }
+	@Override
+	public <T> int set(ValueParam param, T value) {
+		return set(param.getId(), value);
+	}
 
-    @Override
-    public <T> int set(Param param, T value) {
-        return set(param.getId(), value);
-    }
+	@Override
+	public void clearValues() {
+		list.clear();
+	}
 
-    @Override
-    public void clearValues() {
-        list.clear();
-    }
+	/** covariant */
+	@Override
+	public List<Object> getSelected() {
+		return list;
+	}
 
-    /** covariant */
-    @Override
-    public List getSelected() {
-        return list;
-    }
+	@SuppressWarnings("unchecked")
+	@Override
+	public ArrayListAccess select(Object object) {
+		list = (List<Object>) object;
+		return this;
+	}
 
-    @Override
-    public void select(Object object) {
-        list = (List)object;
-    }
+	@Override
+	public String computeIdentifierFor(Object selected) {
+		return Integer.toString(list.size());
+	}
 
-    @Override
-    public String computeIdentifierFor(Object selected) {
-        return Integer.toString(list.size());
-    }
-
-    @Override
-    public Collection<Param> getParams() {
-        List<Param> result = new LinkedList<Param>();
-        if (list == null) {
-            return result;
-        }
-        for (int i = 0; i < list.size(); ++i) {
-            result.add(getParam(i));
-        }
-        return result;
-    }
+	@Override
+	public Collection<Param> getParams() {
+		List<Param> result = new LinkedList<Param>();
+		if (list == null) {
+			return result;
+		}
+		for (int i = 0; i < list.size(); ++i) {
+			result.add(getParam(i));
+		}
+		return result;
+	}
 
 
Index: java/main/src/main/java/com/framsticks/params/CastFailure.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/CastFailure.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/CastFailure.java	(revision 84)
@@ -5,3 +5,9 @@
  */
 public class CastFailure extends Exception {
+
+	/**
+	 *
+	 */
+	private static final long serialVersionUID = 2117813329617553801L;
+
 }
Index: java/main/src/main/java/com/framsticks/params/CompositeParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/CompositeParam.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/CompositeParam.java	(revision 84)
@@ -0,0 +1,35 @@
+package com.framsticks.params;
+
+import com.framsticks.util.lang.Strings;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class CompositeParam extends ValueParam {
+	protected final String containedTypeName;
+
+	public CompositeParam(String containedTypeName) {
+		this.containedTypeName = Strings.notEmpty(containedTypeName) ? containedTypeName : null;
+	}
+
+	public boolean isMatchingContainedName(String name) {
+		assert name != null;
+		if (containedTypeName == null) {
+			return true;
+		}
+		return name.equals(containedTypeName);
+	}
+
+	public String getContainedTypeName() {
+		return containedTypeName;
+	}
+
+	public abstract AccessInterface prepareAccessInterface(AccessInterface access);
+
+	public abstract String computeAccessId();
+
+	public <T> T getDef(Class<T> type) throws ClassCastException {
+		return null;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/params/Flags.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Flags.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/Flags.java	(revision 84)
@@ -3,4 +3,6 @@
 import java.lang.reflect.Field;
 import org.apache.log4j.Logger;
+
+import com.framsticks.util.lang.Delimeted;
 
 /**
@@ -9,5 +11,5 @@
  *
  * Based on c++ defines located in: cpp/gdk/param.h
- * 
+ *
  * @author Jarek Szymczak <name.surname@gmail.com>
  * (please replace name and surname with my personal data)
@@ -17,6 +19,5 @@
 public final class Flags {
 
-	private final static Logger logger = Logger.getLogger(Flags.class.getName());
-
+	private final static Logger log = Logger.getLogger(Flags.class.getName());
 
 	public static final int READONLY = 1;
@@ -48,4 +49,23 @@
 	public static final int PSET_HITMAX = 8;
 
+	public static String write(int flags, String empty) {
+		Delimeted d = new Delimeted("+", empty);
+		try {
+			for (Field f : Flags.class.getDeclaredFields()) {
+				if (f.getType() != int.class) {
+					continue;
+				}
+				if ((flags & f.getInt(null)) != 0) {
+					d.append(f.getName());
+				}
+			}
+		} catch (IllegalArgumentException e) {
+			e.printStackTrace();
+		} catch (IllegalAccessException e) {
+			e.printStackTrace();
+		}
+		return d.build();
+	}
+
 	public static Integer read(String flags) {
 		Integer allFlags = 0;
@@ -59,12 +79,11 @@
 					allFlags |= Integer.parseInt(field.get(null).toString());
 				} catch (SecurityException e) {
-					logger.warn("security exception was thrown while trying to read flag ("
-							+ flag + ")");
+					log.warn("security exception was thrown while trying to read flag (" + flag + ")");
 				} catch (NoSuchFieldException e) {
-					logger.warn("selected flag is not known (" + flag + ")");
+					log.warn("selected flag is not known (" + flag + ")");
 				} catch (IllegalArgumentException e) {
-					logger.warn("selected flag is not known (" + flag + ")");
+					log.warn("selected flag is not known (" + flag + ")");
 				} catch (IllegalAccessException e) {
-					logger.warn("selected flag is not known (" + flag + ")");
+					log.warn("selected flag is not known (" + flag + ")");
 				}
 			}
